/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using MPLAB(c) Code Configurator

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB(c) Code Configurator - 4.0
        Device            :  PIC16F1823
        Driver Version    :  2.00
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.35
        MPLAB             :  MPLAB X 3.40
*/

/*
    (c) 2016 Microchip Technology Inc. and its subsidiaries. You may use this
    software and any derivatives exclusively with Microchip products.

    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED
    WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS FOR A
    PARTICULAR PURPOSE, OR ITS INTERACTION WITH MICROCHIP PRODUCTS, COMBINATION
    WITH ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION.

    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE,
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP HAS
    BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE
    FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN
    ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF ANY,
    THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.

    MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE OF THESE
    TERMS.
*/

#include <xc.h>
#include "main.h"
#include "mcc_generated_files/mcc.h"

volatile uint16_t tick=0;
volatile uint8_t KeyBufferTop=0;
volatile uint8_t KeyBufferBottom=0;
volatile uint8_t KeyBuffer[KEY_BUFFER_SIZE];
volatile uint8_t KeyStat[KEY_STAT_SIZE];
volatile uint8_t RepeatStart=0;
volatile uint8_t RepeatInterval=0;
volatile uint16_t AdcResult;

uint16_t GetAdcResult()
{
    uint8_t i;
    uint16_t result;
    
    result=0;
    for(i=0; i<16; i++){
        result+=ADC_GetConversion(2);
    } // for i
    return result>>4;
} // GetAdcResult
/*
                         Main application
 */
void main(void)
{
    uint8_t i;
    
    // initialize the device
    SYSTEM_Initialize();
    
    LATC=0xff; // scan off
    
    for(i=0; i<KEY_STAT_SIZE; i++) {
        KeyStat[i]=0;
    } // for i
    
    // Enable the Global Interrupts
    INTERRUPT_GlobalInterruptEnable();

    // Enable the Peripheral Interrupts
    INTERRUPT_PeripheralInterruptEnable();

    AdcResult=GetAdcResult();
    if(AdcResult>864) {
        SSP1ADD=0x08<<1; // set slave address 08H
    } else if(AdcResult>598) {
        SSP1ADD=0x09<<1; // set slave address 09H        
    } else if(AdcResult>460) {
        SSP1ADD=0x0a<<1; // set slave address 0AH        
    } else {
        SSP1ADD=0x0b<<1; // set slave address 0BH                
    } // if
    
    while (1)
    {
    }
}
/**
 End of File
*/